/*global dump*/
"use strict";

console.log("Loading mraidext.js");

(function () {
    // Root bridge object handler
    var mraidext = window.mraid_ext = {};

    //////////////////////////////////////////////////////////////////////////////////////////////////
    mraidext.start = function () {
        console.log("Firing start event!");
        window.mraidbridge.executeNativeCallWithScheme('mraidext', 'start');
    };

    mraidext.credit = function (data) {
        console.log("mraidext.credit");
        console.log("firing credit event! with data: " + dump(data));
        var call = "mraidext://credit";

        if (data && data.payload && data.signature) {
            window.mraidbridge.executeNativeCallWithScheme('mraidext', 'credit', 'payload', data.payload, 'signature', data.signature);
        } else {
            window.mraidbridge.executeNativeCallWithScheme('mraidext', 'credit');
        }
    };

    mraidext.finish = function () {
        console.log("firing finish event!");
        window.mraidbridge.executeNativeCallWithScheme('mraidext', 'finish');
    };

    mraidext.toast = function (message, duration) {
        console.log("mraidext.toast");
        window.mraidbridge.executeNativeCallWithScheme('mraidext', 'toast', 'message', message, 'duration', duration);
    };

    mraidext.report = function (type, params) {
        console.log("mraidext.report - " + type);
        if (params !== null && (typeof params === 'object')) {
            window.mraidbridge.executeNativeCallWithScheme('mraidext', 'report', 'type', type, 'params', JSON.stringify(params));
        } else {
            window.mraidbridge.fireErrorEvent('params expected to be object, actual type: ' + (typeof params), 'mraidext.report');
        }
    };

    mraidext.failedToStart = function () {
        console.log("Firing failed to start event!");
        window.mraidbridge.executeNativeCallWithScheme('mraidext', 'failedtostart');
    };

    mraidext.proceed = function () {
        console.log("mraidext.proceed");
        window.mraidbridge.executeNativeCallWithScheme('mraidext', 'proceed');
    };

}());
